---
layout: lesson
title: Data carpentry: R for data analysis and visualization of Ecological Data
keywords: ["R", "subset", "data.frame", "read.csv", "dplyr", "ggplot2"]
---

This is an introduction to R designed for participants with no programming
experience. These lessons can be taught in 3/4 of a day (6 hours). They start
with some basic information about syntax for the R programming language, the
RStudio interface, and move through to specific programming tasks, such as
importing CSV files, the structure of data frame objects in R, dealing with
categorical variables (i.e. factors), basic data manipulation (adding/removing
rows and columns), and finishing with calculating summary statistics and a brief
introduction to plotting. There is also a lesson on how to use databases from R that is intended to be taught after the SQL lesson, and ideally at the end of a Data Carpentry workshop.

## Prerequisites

> * Having R and RStudio installed (though see the first
> lesson, [Before we start](00-before-we-start.html) for installation
> instructions)

## Topics

* [Before we start](00-before-we-start.html)
* [Introduction to R](01-intro-to-r.html)
* [Starting with data](02-starting-with-data.html)
* [Aggregating and analyzing data with dplyr](03-dplyr.html)
* [Data visualization with ggplot2](04-visualization-ggplot2.html)
* [R and Databases](05-r-and-databases.html)

## Code handout

There is "[code handout](code-handout.R)" (`code-handout.R`) that is intended to
be distributed to the participants. This file includes some of the examples used
during teaching and the titles of the section. It provides a guide that the
participants can fill in as the lesson progresses. Participants can also source
code from this file to avoid typos in more complex examples.

## Contributing

If you would like to contribute to the content and development of these lessons,
we encourage you to review our [contributing guide](CONTRIBUTING.md).

## Questions

If you have any questions or feedback, please open an issue or contact the
maintainers:

* François Michonneau
* Auriel Fournier
